# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.2

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

class CurrencyFormatterMode(enum.IntEnum):
    USE_SYMBOL = 0
    USE_CURRENCY_CODE = 1

class RoundingAlgorithm(enum.IntEnum):
    NONE = 0
    ROUND_DOWN = 1
    ROUND_UP = 2
    ROUND_TOWARDS_ZERO = 3
    ROUND_AWAY_FROM_ZERO = 4
    ROUND_HALF_DOWN = 5
    ROUND_HALF_UP = 6
    ROUND_HALF_TOWARDS_ZERO = 7
    ROUND_HALF_AWAY_FROM_ZERO = 8
    ROUND_HALF_TO_EVEN = 9
    ROUND_HALF_TO_ODD = 10

class CurrencyFormatter(INumberParser, INumberFormatter2, INumberFormatter, INumberFormatterOptions, ISignificantDigitsOption, INumberRounderOption, ISignedZeroOption, _winrt.Object):
    currency: str
    mode: CurrencyFormatterMode
    numeral_system: str
    is_grouped: _winrt.Boolean
    is_decimal_point_always_displayed: _winrt.Boolean
    integer_digits: _winrt.Int32
    fraction_digits: _winrt.Int32
    geographic_region: str
    resolved_geographic_region: str
    resolved_language: str
    languages: winsdk.windows.foundation.collections.IVectorView[str]
    number_rounder: INumberRounder
    is_zero_signed: _winrt.Boolean
    significant_digits: _winrt.Int32
    @staticmethod
    def _from(obj: _winrt.Object) -> CurrencyFormatter: ...
    @typing.overload
    def __init__(self, currency_code: str) -> None: ...
    @typing.overload
    def __init__(self, currency_code: str, languages: typing.Iterable[str], geographic_region: str) -> None: ...
    @typing.overload
    def apply_rounding_for_currency(self, rounding_algorithm: RoundingAlgorithm) -> None: ...
    @typing.overload
    def format(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_double(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_int(self, value: _winrt.Int64) -> str: ...
    @typing.overload
    def format_uint(self, value: _winrt.UInt64) -> str: ...
    @typing.overload
    def parse_double(self, text: str) -> typing.Optional[_winrt.Double]: ...
    @typing.overload
    def parse_int(self, text: str) -> typing.Optional[_winrt.Int64]: ...
    @typing.overload
    def parse_uint(self, text: str) -> typing.Optional[_winrt.UInt64]: ...

class DecimalFormatter(INumberFormatterOptions, INumberFormatter, INumberFormatter2, INumberParser, ISignificantDigitsOption, INumberRounderOption, ISignedZeroOption, _winrt.Object):
    is_decimal_point_always_displayed: _winrt.Boolean
    integer_digits: _winrt.Int32
    is_grouped: _winrt.Boolean
    numeral_system: str
    fraction_digits: _winrt.Int32
    geographic_region: str
    languages: winsdk.windows.foundation.collections.IVectorView[str]
    resolved_geographic_region: str
    resolved_language: str
    number_rounder: INumberRounder
    is_zero_signed: _winrt.Boolean
    significant_digits: _winrt.Int32
    @staticmethod
    def _from(obj: _winrt.Object) -> DecimalFormatter: ...
    @typing.overload
    def __init__(self, languages: typing.Iterable[str], geographic_region: str) -> None: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def format(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_double(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_int(self, value: _winrt.Int64) -> str: ...
    @typing.overload
    def format_uint(self, value: _winrt.UInt64) -> str: ...
    @typing.overload
    def parse_double(self, text: str) -> typing.Optional[_winrt.Double]: ...
    @typing.overload
    def parse_int(self, text: str) -> typing.Optional[_winrt.Int64]: ...
    @typing.overload
    def parse_uint(self, text: str) -> typing.Optional[_winrt.UInt64]: ...

class IncrementNumberRounder(INumberRounder, _winrt.Object):
    rounding_algorithm: RoundingAlgorithm
    increment: _winrt.Double
    @staticmethod
    def _from(obj: _winrt.Object) -> IncrementNumberRounder: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def round_double(self, value: _winrt.Double) -> _winrt.Double: ...
    @typing.overload
    def round_int32(self, value: _winrt.Int32) -> _winrt.Int32: ...
    @typing.overload
    def round_int64(self, value: _winrt.Int64) -> _winrt.Int64: ...
    @typing.overload
    def round_single(self, value: _winrt.Single) -> _winrt.Single: ...
    @typing.overload
    def round_uint32(self, value: _winrt.UInt32) -> _winrt.UInt32: ...
    @typing.overload
    def round_uint64(self, value: _winrt.UInt64) -> _winrt.UInt64: ...

class NumeralSystemTranslator(_winrt.Object):
    numeral_system: str
    languages: winsdk.windows.foundation.collections.IVectorView[str]
    resolved_language: str
    @staticmethod
    def _from(obj: _winrt.Object) -> NumeralSystemTranslator: ...
    @typing.overload
    def __init__(self, languages: typing.Iterable[str]) -> None: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def translate_numerals(self, value: str) -> str: ...

class PercentFormatter(INumberFormatterOptions, INumberFormatter, INumberFormatter2, INumberParser, ISignificantDigitsOption, INumberRounderOption, ISignedZeroOption, _winrt.Object):
    is_decimal_point_always_displayed: _winrt.Boolean
    integer_digits: _winrt.Int32
    is_grouped: _winrt.Boolean
    numeral_system: str
    fraction_digits: _winrt.Int32
    geographic_region: str
    languages: winsdk.windows.foundation.collections.IVectorView[str]
    resolved_geographic_region: str
    resolved_language: str
    number_rounder: INumberRounder
    is_zero_signed: _winrt.Boolean
    significant_digits: _winrt.Int32
    @staticmethod
    def _from(obj: _winrt.Object) -> PercentFormatter: ...
    @typing.overload
    def __init__(self, languages: typing.Iterable[str], geographic_region: str) -> None: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def format(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_double(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_int(self, value: _winrt.Int64) -> str: ...
    @typing.overload
    def format_uint(self, value: _winrt.UInt64) -> str: ...
    @typing.overload
    def parse_double(self, text: str) -> typing.Optional[_winrt.Double]: ...
    @typing.overload
    def parse_int(self, text: str) -> typing.Optional[_winrt.Int64]: ...
    @typing.overload
    def parse_uint(self, text: str) -> typing.Optional[_winrt.UInt64]: ...

class PermilleFormatter(INumberFormatterOptions, INumberFormatter, INumberFormatter2, INumberParser, ISignificantDigitsOption, INumberRounderOption, ISignedZeroOption, _winrt.Object):
    is_decimal_point_always_displayed: _winrt.Boolean
    integer_digits: _winrt.Int32
    is_grouped: _winrt.Boolean
    numeral_system: str
    fraction_digits: _winrt.Int32
    geographic_region: str
    languages: winsdk.windows.foundation.collections.IVectorView[str]
    resolved_geographic_region: str
    resolved_language: str
    number_rounder: INumberRounder
    is_zero_signed: _winrt.Boolean
    significant_digits: _winrt.Int32
    @staticmethod
    def _from(obj: _winrt.Object) -> PermilleFormatter: ...
    @typing.overload
    def __init__(self, languages: typing.Iterable[str], geographic_region: str) -> None: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def format(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_double(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_int(self, value: _winrt.Int64) -> str: ...
    @typing.overload
    def format_uint(self, value: _winrt.UInt64) -> str: ...
    @typing.overload
    def parse_double(self, text: str) -> typing.Optional[_winrt.Double]: ...
    @typing.overload
    def parse_int(self, text: str) -> typing.Optional[_winrt.Int64]: ...
    @typing.overload
    def parse_uint(self, text: str) -> typing.Optional[_winrt.UInt64]: ...

class SignificantDigitsNumberRounder(INumberRounder, _winrt.Object):
    significant_digits: _winrt.UInt32
    rounding_algorithm: RoundingAlgorithm
    @staticmethod
    def _from(obj: _winrt.Object) -> SignificantDigitsNumberRounder: ...
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def round_double(self, value: _winrt.Double) -> _winrt.Double: ...
    @typing.overload
    def round_int32(self, value: _winrt.Int32) -> _winrt.Int32: ...
    @typing.overload
    def round_int64(self, value: _winrt.Int64) -> _winrt.Int64: ...
    @typing.overload
    def round_single(self, value: _winrt.Single) -> _winrt.Single: ...
    @typing.overload
    def round_uint32(self, value: _winrt.UInt32) -> _winrt.UInt32: ...
    @typing.overload
    def round_uint64(self, value: _winrt.UInt64) -> _winrt.UInt64: ...

class INumberFormatter(_winrt.Object):
    @staticmethod
    def _from(obj: _winrt.Object) -> INumberFormatter: ...
    @typing.overload
    def format(self, value: _winrt.Double) -> str: ...

class INumberFormatter2(_winrt.Object):
    @staticmethod
    def _from(obj: _winrt.Object) -> INumberFormatter2: ...
    @typing.overload
    def format_double(self, value: _winrt.Double) -> str: ...
    @typing.overload
    def format_int(self, value: _winrt.Int64) -> str: ...
    @typing.overload
    def format_uint(self, value: _winrt.UInt64) -> str: ...

class INumberFormatterOptions(_winrt.Object):
    fraction_digits: _winrt.Int32
    geographic_region: str
    integer_digits: _winrt.Int32
    is_decimal_point_always_displayed: _winrt.Boolean
    is_grouped: _winrt.Boolean
    languages: winsdk.windows.foundation.collections.IVectorView[str]
    numeral_system: str
    resolved_geographic_region: str
    resolved_language: str
    @staticmethod
    def _from(obj: _winrt.Object) -> INumberFormatterOptions: ...

class INumberParser(_winrt.Object):
    @staticmethod
    def _from(obj: _winrt.Object) -> INumberParser: ...
    @typing.overload
    def parse_double(self, text: str) -> typing.Optional[_winrt.Double]: ...
    @typing.overload
    def parse_int(self, text: str) -> typing.Optional[_winrt.Int64]: ...
    @typing.overload
    def parse_uint(self, text: str) -> typing.Optional[_winrt.UInt64]: ...

class INumberRounder(_winrt.Object):
    @staticmethod
    def _from(obj: _winrt.Object) -> INumberRounder: ...
    @typing.overload
    def round_double(self, value: _winrt.Double) -> _winrt.Double: ...
    @typing.overload
    def round_int32(self, value: _winrt.Int32) -> _winrt.Int32: ...
    @typing.overload
    def round_int64(self, value: _winrt.Int64) -> _winrt.Int64: ...
    @typing.overload
    def round_single(self, value: _winrt.Single) -> _winrt.Single: ...
    @typing.overload
    def round_uint32(self, value: _winrt.UInt32) -> _winrt.UInt32: ...
    @typing.overload
    def round_uint64(self, value: _winrt.UInt64) -> _winrt.UInt64: ...

class INumberRounderOption(_winrt.Object):
    number_rounder: INumberRounder
    @staticmethod
    def _from(obj: _winrt.Object) -> INumberRounderOption: ...

class ISignedZeroOption(_winrt.Object):
    is_zero_signed: _winrt.Boolean
    @staticmethod
    def _from(obj: _winrt.Object) -> ISignedZeroOption: ...

class ISignificantDigitsOption(_winrt.Object):
    significant_digits: _winrt.Int32
    @staticmethod
    def _from(obj: _winrt.Object) -> ISignificantDigitsOption: ...

